#define addres 0x27
#define lines 4
#define sim 20
#define ENC_TYPE TYPE2
#define S1 7
#define S2 6
#define Key 5

#include <LCD_1602_RUS.h>
#include <GyverEncoder.h>
#include <EEPROM.h>

LCD_1602_RUS lcd(addres, sim, lines);
Encoder enc(S1, S2, Key, ENC_TYPE);

byte punt = 1;
byte puntTimer = 1;
byte puntStopwatch = 1;
int sec = 0;
int min = 0;
int fps = 0;
boolean clear = false;
boolean lock = false;
boolean flag = false;

/*-------Dino-переменые-------*/
byte yDino = 3;
byte xNew = 20;
byte xOld = 0;
byte jumpDinoPos = 0;
boolean jumpDino = false;
boolean oneCact = false;
boolean exitDino = false;
uint64_t fpsInGame;
uint16_t fpsInGameCol;
uint16_t timeTickDino = 100;

#define puntMax 3
#define timeTick 50
#define ok 5
#define next 7
#define back 6

void setup() {
  lcd.init();
  pinMode(13, OUTPUT);
  digitalWrite(13, false);
  lcd.backlight();
  lcd.clear();
  for (byte cadr = 1; cadr <= 4; cadr++) {
    byte counter = 0;
    for (byte y = 0; y < 4; y++) {
      for (byte x = 0; x < 20; x++) {
        counter++;
        lcd.setCursor(x, y);
        if (cadr == 1) {
          switch (counter) {
            case 6: lcd.print('#'); break;
            case 7: lcd.print('#'); break;
            case 8: lcd.print('#'); break;
            case 12: lcd.print('#'); break;
            case 16: lcd.print('#'); break;
            default: lcd.print(' '); break;
          }
        }
        if (cadr == 2) {
          switch (counter) {
            case 6: lcd.print('#'); break;
            case 7: lcd.print('#'); break;
            case 8: lcd.print('#'); break;
            case 12: lcd.print('#'); break;
            case 16: lcd.print('#'); break;
            case 25: lcd.print('#'); break;
            case 32: lcd.print('#'); break;
            case 36: lcd.print('#'); break;
            default: lcd.print(' '); break;
          }
        }
        if (cadr == 3) {
          switch (counter) {
            case 6: lcd.print('#'); break;
            case 7: lcd.print('#'); break;
            case 8: lcd.print('#'); break;
            case 12: lcd.print('#'); break;
            case 16: lcd.print('#'); break;
            case 25: lcd.print('#'); break;
            case 32: lcd.print('#'); break;
            case 36: lcd.print('#'); break;
            case 45: lcd.print('#'); break;
            case 52: lcd.print('#'); break;
            case 54: lcd.print('#'); break;
            case 56: lcd.print('#'); break;
            default: lcd.print(' '); break;
          }
        }
        if (cadr == 4) {
          switch (counter) {
            case 6: lcd.print('#'); break;
            case 7: lcd.print('#'); break;
            case 8: lcd.print('#'); break;
            case 12: lcd.print('#'); break;
            case 16: lcd.print('#'); break;
            case 25: lcd.print('#'); break;
            case 32: lcd.print('#'); break;
            case 36: lcd.print('#'); break;
            case 45: lcd.print('#'); break;
            case 52: lcd.print('#'); break;
            case 54: lcd.print('#'); break;
            case 56: lcd.print('#'); break;
            case 66: lcd.print('#'); break;
            case 67: lcd.print('#'); break;
            case 68: lcd.print('#'); break;
            case 73: lcd.print('#'); break;
            case 75: lcd.print('#'); break;
            default: lcd.print(' '); break;
          }
        }
      }
    }
  }
  if (EEPROM.read(0) == 'y') {
    if (EEPROM.read(1) == 't') {
      int temp = 0;
      int tmp = 0;
      EEPROM.get(2, temp);
      min = temp / 60;
      tmp = temp - (min * 60);
      sec = tmp;
      punt = 1;
      puntTimer = 4;
      flag = true;
    }
    if (EEPROM.read(1) == 's') {
      int temp = 0;
      int tmp = 0;
      EEPROM.get(2, temp);
      min = temp / 60;
      tmp = temp - (min * 60);
      sec = tmp;
      punt = 2;
      puntStopwatch = 2;
      flag = true;
    }
  }
  delay(1000);
  lcd.clear();
  lcd.setCursor(8, 1);
  lcd.print("ASC");
  lcd.setCursor(4, 2);
  lcd.print("ChudoWindows");
  delay(2000);
  clear = true;
}

void loop() {
  encoder();
  static uint32_t updDevice;
  static uint32_t frameRate;
  static byte tmpFps;
  if (millis() - updDevice >= timeTick) {
    updDevice = millis();
    if (clear or (punt == 3 and flag)) {
      clear = false;
      lcd.clear();
    }
    lcd.setCursor(0, 0);
    lcd.print("   ");
    lcd.setCursor(0, 0);
    lcd.print(fps);
    if (flag) program();
    else menu();
  }
  if (millis() - frameRate >= 1000) {
    frameRate = millis();
    fps = tmpFps;
    tmpFps = 0;
  }
  tmpFps++;
}

void menu() {
  switch (punt) {
    case 1:
      lcd.setCursor(7, 1);
      lcd.print(L"Таймер");
      break;
    case 2:
      lcd.setCursor(5, 1);
      lcd.print(L"Сеkундомер");
      break;
    case 3:
      lcd.setCursor(8, 1);
      lcd.print("Dino");
      break;
  }
}

void program() {
  switch (punt) {
    case 1:
      if (puntTimer == 1) {
        lcd.setCursor(7, 0);
        lcd.print(L"Таймер");
        lcd.setCursor(8, 2);
        if (min < 10) {
          lcd.print('0');
          lcd.print(min);
        }
        else lcd.print(min);
        lcd.print(':');
        if (sec < 10) {
          lcd.print('0');
          lcd.print(sec);
        }
        else lcd.print(sec);
      }
      if (puntTimer == 2) {
        static uint8_t counterTimer = 0;
        if (counterTimer == (1000 / timeTick)) {
          counterTimer = 0;
          if (sec == 0 and min != 0) {
            min--;
            sec = 59;
            return;
          } else if (sec != 0) {
            sec--;
          } else {
            puntTimer++;
            EEPROM.update(0, 'n');
            clear = true;
          }
        }
        else counterTimer++;
        lcd.setCursor(7, 0);
        lcd.print(L"Таймер");
        lcd.setCursor(8, 2);
        if (min < 10) {
          lcd.print('0');
          lcd.print(min);
        }
        else lcd.print(min);
        lcd.print(':');
        if (sec < 10) {
          lcd.print('0');
          lcd.print(sec);
        }
        else lcd.print(sec);
        lcd.setCursor(0, 3);
        lcd.print(L"<------<Идёт>------>");
      }
      if (puntTimer == 3) {
        lcd.setCursor(7, 0);
        lcd.print(L"Таймер");
        lcd.setCursor(0, 3);
        lcd.print(L"<------<Конец>----->");
      }
      if (puntTimer == 4) {
        lcd.setCursor(7, 0);
        lcd.print(L"Таймер");
        lcd.setCursor(0, 3);
        lcd.print(L"<------<Пауза>----->");
        lcd.setCursor(8, 2);
        if (min < 10) {
          lcd.print('0');
          lcd.print(min);
        }
        else lcd.print(min);
        lcd.print(':');
        if (sec < 10) {
          lcd.print('0');
          lcd.print(sec);
        }
        else lcd.print(sec);
      }
      break;
    case 2:
      if (puntStopwatch == 1) {
        static uint8_t counterStopwatch = 0;
        if (counterStopwatch == (1000 / timeTick)) {
          counterStopwatch = 0;
          sec++;
          if (sec == 60) {
            min++;
            sec = 0;
          }
        }
        else counterStopwatch++;
        lcd.setCursor(5, 0);
        lcd.print(L"Сеkундомер");
        lcd.setCursor(8, 2);
        if (min < 10) {
          lcd.print('0');
          lcd.print(min);
        }
        else lcd.print(min);
        lcd.print(':');
        if (sec < 10) {
          lcd.print('0');
          lcd.print(sec);
        }
        else lcd.print(sec);
        lcd.setCursor(0, 3);
        lcd.print(L"<------<Идёт>------>");
      }
      if (puntStopwatch == 2) {
        lcd.setCursor(5, 0);
        lcd.print(L"Сеkундомер");
        lcd.setCursor(8, 2);
        if (min < 10) {
          lcd.print('0');
          lcd.print(min);
        }
        else lcd.print(min);
        lcd.print(':');
        if (sec < 10) {
          lcd.print('0');
          lcd.print(sec);
        }
        else lcd.print(sec);
        lcd.setCursor(0, 3);
        lcd.print(L"<------<Пауза>----->");
      }
      break;
    case 3:
      static uint32_t timerJump = 0;
      static int counter = 0;
      static uint16_t oldFps = 0;
      static uint16_t counterInTick = 0;
      //if (xNew < 16) {
      //  jumpDino = true;
      //}
      lcd.setCursor(0, 1);
      lcd.print(counter);
      int tmp = yDino;
      tmp = tmp - 1;
      lcd.setCursor(10, tmp);
      lcd.print(' ');
      lcd.setCursor(10, yDino);
      lcd.print('#');
      tmp = xNew;
      tmp = tmp - 1;
      lcd.setCursor(tmp, 3);
      lcd.print(' ');
      lcd.setCursor(xNew, 3);
      lcd.print('*');
      if (oneCact) {
        tmp = xOld;
        tmp = tmp - 1;
        lcd.setCursor(tmp, 3);
        lcd.print(' ');
        lcd.setCursor(xOld, 3);
        lcd.print('*');
      }
      if (millis() - timerJump >= timeTickDino) {
        timerJump = millis();
        if (oldFps != fps) {
          fpsInGame += fps;
          fpsInGameCol++;
          oldFps = fps;
        }
        if (xNew == 10 and yDino != 3) {
          xOld = xNew;
          xNew = 20;
          counter++;
          counterInTick++;
          if (counterInTick == 10 ) {
            counterInTick = 0;
            if (timeTickDino != 10)timeTickDino -= 10;
          }
          if (!oneCact) oneCact = true;
        } else if (xNew == 10 and yDino == 3) {
          exitDino = true;
        }
        if (exitDino) {
          xNew = 20;
          xOld = 0;
          oneCact = false;
          int fpsSr = (fpsInGame / fpsInGameCol);
          lcd.clear();
          lcd.setCursor(4, 0);
          lcd.print(L"Счёт: ");
          lcd.print(counter);
          lcd.setCursor(4, 2);
          lcd.print("FPS: ");
          lcd.print(fpsSr);
          delay(2000);
          counter = 0;
          fpsInGame = 0;
          fpsInGameCol = 0;
          clear = true;
          flag = false;
          exitDino = false;
        }
        xNew--;
        if (xOld != 0) xOld--;
        if (jumpDino) {
          jumpDinoPos++;
          if (jumpDinoPos < 4) {
            yDino--;
          } else if (jumpDinoPos > 3 and jumpDinoPos < 7) {
            yDino++;
          }
          if (jumpDinoPos == 6) {
            jumpDino = false;
            jumpDinoPos = 0;
          }
        }
      }
      break;
  }
}

void encoder() {
  enc.tick();
  if (enc.isRight()) {
    if (flag == false and lock == false and punt != puntMax) {
      punt++;
      clear = true;
    }
    if (flag == true) {
      if (punt == 1) {
        if (sec == 59) {
          sec = 0;
          min++;
        }
        else sec++;
      }
    }
  }
  if (enc.isLeft()) {
    if (flag == false and lock == false and punt != 1) {
      punt--;
      clear = true;
    }
    if (flag == true) {
      if (punt == 1) {
        if (sec == 0 and min != 0) {
          min--;
          sec = 59;
          return;
        }
        if (sec != 0) {
          sec--;
        }
      }
    }
  }
  if (enc.isRightH()) {
    if (flag) {
      if (punt == 1) {
        min++;
      }
    }
  }
  if (enc.isLeftH()) {
    if (flag) {
      if (punt == 1) {
        if (min != 0) min--;
      }
    }
  }
  if (enc.isClick()) {
    if (flag == true) {
      if (punt == 1 and puntTimer == 1) {
        puntTimer++;
        return;
      }
      if (punt == 1 and puntTimer == 4) {
        clear = true;
        puntTimer = 2;
        return;
      }
      if (punt == 1 and puntTimer == 2) {
        EEPROM.update(0, 'y');
        EEPROM.update(1, 't');
        int tmp = min * 60 + sec;
        EEPROM.put(2, tmp);
        clear = true;
        puntTimer = 4;
        return;
      }
      if (punt == 2 and puntStopwatch == 2) {
        puntStopwatch = 1;
        return;
      }
      if (punt == 2 and puntStopwatch == 1) {
        EEPROM.update(0, 'y');
        EEPROM.update(1, 's');
        int tmp = min * 60 + sec;
        EEPROM.put(2, tmp);
        clear = true;
        puntStopwatch = 2;
        return;
      }
      if (punt == 3) {
        jumpDino = true;
      }
    }
    if (flag == false) {
      flag = true;
      clear = true;
    }
  }
  if (enc.isHolded()) {
    clear = true;
    if (punt == 3 and flag) exitDino = true;
    if (flag and punt != 3) flag = false;
    puntTimer = 1;
    puntStopwatch = 1;
    sec = 0;
    min = 0;
    EEPROM.update(0, 'n');
  }
}
